unit JCDes;

{$N-}   { ᯮ짮+ ᫮ ᮯ ( 窠)            }
{$E-}   { + (⪫-) ० 樨 ᮯ              }

{$IFDEF Ver70}
{$P-}   { Open String Parameters Swich                                    }
{$Q-}   { + (⪫-) ஫ ९ . .       }
{$T-}   { ஫ @, ⨯஢-, ⨯஢+         }
{$ENDIF}

{$A-}   { ࠢ   ࠭ ᫮+ (-)                   }
{$B-}   {  ᪨ ࠦ +                       }
{$D+}   { +, (-) ࠡ  ஥ ⫠稪        }
{$F-}   { ᯮ짮 + (-)  맮                  }
{$G-}   { ᯮ짮  +  I80286,  I8088 -           }
{$I-}   { + (⪫-) ஫ 権 -뢮           }
{$L+}   { + (⪫-)  ᨬ  ⫠稪          }
{$O-}   { + (p-)ᮧ ૥             }
{$R-}   { + (⪫-) ஫                        }
{$S-}   { + (⪫-) ஫ ९ ⥪              }
{$V-}   { + (⪫-) ஫  ப                     }
{$X+}   { ᯮ짮+ ( ᯮ짮-) ७ ᨭ⠪          }

  interface

    const
      MaxInd = 008;         { 64 Bits block (8 bytes)                     }
      Mask1  = 001;         { Binary = 00000001                           }
      Mask2  = 254;         { Binary = 11111110                           }
    type
      DArray  = array[1..MaxInd] of char;                  {  8 Chars     }

      Array1  = array[1..MaxInd * MaxInd] of byte;         { 64 Bytes     }
      Array21 = array[1..MaxInd - 1] of char;              {  7 Chars     }
      Array3  = array[1..MaxInd * (MaxInd - 2)] of byte;   { 48 Bytes     }
      Array31 = array[1..MaxInd - 2] of char;              {  6 Chars     }
      Array4  = array[1..MaxInd * (MaxInd - 4)] of byte;   { 32 Bytes     }
      Array41 = array[1..MaxInd - 4] of char;              {  4 Chars     }
      Array5  = array[1..MaxInd * (MaxInd - 1)] of byte;   { 56 Bytes     }
      Array6  = array[1..MaxInd * 2] of byte;              { 16 Bytes     }
    const
      IP   : Array1 = (58, 50, 42, 34, 26, 18, 10, 02,
                       60, 52, 44, 36, 28, 20, 12, 04,
                       62, 54, 46, 38, 30, 22, 14, 06,
                       64, 56, 48, 40, 32, 24, 16, 08,
                       57, 49, 41, 33, 25, 17, 09, 01,
                       59, 51, 43, 35, 27, 19, 11, 03,
                       61, 53, 45, 37, 29, 21, 13, 05,
                       63, 55, 47, 39, 31, 23, 15, 07);

      IP_1 : Array1 = (40, 08, 48, 16, 56, 24, 64, 32,
                       39, 07, 47, 15, 55, 23, 63, 31,
                       38, 06, 46, 14, 54, 22, 62, 30,
                       37, 05, 45, 13, 53, 21, 61, 29,
                       36, 04, 44, 12, 52, 20, 60, 28,
                       35, 03, 43, 11, 51, 19, 59, 27,
                       34, 02, 42, 10, 50, 18, 58, 26,
                       33, 01, 41, 09, 49, 17, 57, 25);

      StE  : Array1 = (01, 02, 03, 04, 05, 06, 07, 08,
                       07, 08, 09, 10, 11, 12, 15, 16,
                       13, 14, 15, 16, 17, 18, 23, 24,
                       19, 20, 21, 22, 23, 24, 31, 32,
                       25, 26, 27, 28, 29, 30, 39, 40,
                       31, 32, 33, 34, 35, 36, 47, 48,
                       37, 38, 39, 40, 41, 42, 07, 08,
                       43, 44, 45, 46, 47, 48, 15, 16);

      E    : Array3 = (32, 01, 02, 03, 04, 05,
                       04, 05, 06, 07, 08, 09,
                       08, 09, 10, 11, 12, 13,
                       12, 13, 14, 15, 16, 17,
                       16, 17, 18, 19, 20, 21,
                       20, 21, 22, 23, 24, 25,
                       24, 25, 26, 27, 28, 29,
                       28, 29, 30, 31, 32, 01);

      S1   : Array1 = (14, 04, 13, 01, 02, 15, 11, 08, 03, 10, 06, 12, 05, 09, 00, 07,
                       00, 15, 07, 04, 14, 02, 13, 01, 10, 06, 12, 11, 09, 05, 03, 08,
                       04, 01, 14, 08, 13, 06, 02, 11, 15, 12, 09, 07, 03, 10, 05, 00,
                       15, 12, 08, 02, 04, 09, 01, 07, 05, 11, 03, 14, 10, 00, 06, 13);

      S2   : Array1 = (15, 01, 08, 14, 06, 11, 03, 04, 09, 07, 02, 13, 12, 00, 05, 10,
                       03, 13, 04, 07, 15, 02, 08, 14, 12, 00, 01, 10, 06, 09, 11, 05,
                       00, 14, 07, 11, 10, 04, 13, 01, 05, 08, 12, 06, 09, 03, 02, 15,
                       13, 08, 10, 01, 03, 15, 04, 02, 11, 06, 07, 12, 00, 05, 14, 09);

      S3   : Array1 = (10, 00, 09, 14, 06, 03, 15, 05, 01, 13, 12, 07, 11, 04, 02, 08,
                       13, 07, 00, 09, 03, 04, 06, 10, 02, 08, 05, 14, 12, 11, 15, 01,
                       13, 06, 04, 09, 08, 15, 03, 00, 11, 01, 02, 12, 05, 10, 14, 07,
                       01, 10, 13, 00, 06, 09, 08, 07, 04, 15, 14, 03, 11, 05, 02, 12);

      S4   : Array1 = (07, 13, 14, 03, 00, 06, 09, 10, 01, 02, 08, 05, 11, 12, 04, 15,
                       13, 08, 11, 05, 06, 15, 00, 03, 04, 07, 02, 12, 01, 10, 14, 09,
                       10, 06, 09, 00, 12, 11, 07, 13, 15, 01, 03, 14, 05, 02, 08, 04,
                       03, 15, 00, 06, 10, 01, 13, 08, 09, 04, 05, 11, 12, 07, 02, 14);

      S5   : Array1 = (02, 12, 04, 01, 07, 10, 11, 06, 08, 05, 03, 15, 13, 00, 14, 09,
                       14, 11, 02, 12, 04, 07, 13, 01, 05, 00, 15, 10, 03, 09, 08, 06,
                       04, 02, 01, 11, 10, 13, 07, 08, 15, 09, 12, 05, 06, 03, 00, 14,
                       11, 08, 12, 07, 01, 14, 02, 13, 06, 15, 00, 09, 10, 04, 05, 03);

      S6   : Array1 = (12, 01, 10, 15, 09, 02, 06, 08, 00, 13, 03, 04, 14, 07, 05, 11,
                       10, 15, 04, 02, 07, 12, 09, 05, 06, 01, 13, 14, 00, 11, 03, 08,
                       09, 14, 15, 05, 02, 08, 12, 03, 07, 00, 04, 10, 01, 13, 11, 06,
                       04, 03, 02, 12, 09, 05, 15, 10, 11, 14, 01, 07, 06, 00, 08, 13);

      S7   : Array1 = (04, 11, 02, 14, 15, 00, 08, 13, 03, 12, 09, 07, 05, 10, 06, 01,
                       13, 00, 11, 07, 04, 09, 01, 10, 14, 03, 05, 12, 02, 15, 08, 06,
                       01, 04, 11, 13, 12, 03, 07, 14, 10, 15, 06, 08, 00, 05, 09, 02,
                       06, 11, 13, 08, 01, 04, 10, 07, 09, 05, 00, 15, 14, 02, 03, 12);

      S8   : Array1 = (13, 02, 08, 04, 06, 15, 11, 01, 10, 09, 03, 14, 05, 00, 12, 07,
                       01, 15, 13, 08, 10, 03, 07, 04, 12, 05, 06, 11, 00, 14, 09, 02,
                       07, 11, 04, 01, 09, 12, 14, 02, 00, 06, 10, 13, 15, 03, 05, 08,
                       02, 01, 14, 07, 04, 10, 08, 13, 15, 12, 09, 00, 03, 05, 06, 11);

      P    : Array4 = (16, 07, 20, 21,
                       29, 12, 28, 17,
                       01, 15, 23, 26,
                       05, 18, 31, 10,
                       02, 08, 24, 14,
                       32, 27, 03, 09,
                       19, 13, 30, 06,
                       22, 11, 04, 25);

      PC_1 : Array5 = (57, 49, 41, 33, 25, 17, 09,
                       01, 58, 50, 42, 34, 26, 18,
                       10, 02, 59, 51, 43, 35, 27,
                       19, 11, 03, 60, 52, 44, 36,
                       63, 55, 47, 39, 31, 23, 15,
                       07, 62, 54, 46, 38, 30, 22,
                       14, 06, 61, 53, 45, 37, 29,
                       21, 13, 05, 28, 20, 12, 04);

      PC_2 : Array3 = (14, 17, 11, 24, 01, 05,
                       03, 28, 15, 06, 21, 10,
                       23, 19, 12, 04, 26, 08,
                       16, 07, 27, 20, 13, 02,
                       41, 52, 31, 37, 47, 55,
                       30, 40, 51, 45, 33, 48,
                       44, 49, 39, 56, 34, 53,
                       46, 42, 50, 36, 29, 32);

      LS   : Array6 = (01, 01, 02, 02, 02, 02, 02, 02,
                       01, 02, 02, 02, 02, 02, 02, 01);
    type
      PDes = ^TDes;
      TDes = object
{      private }
        procedure GetValues(const Index : byte; var NByte, Bit : byte);
        function  ReadBit(const Block : array of char; const Index : byte) : byte;
        procedure WriteBit(const Index, WrBit : byte; var Block : array of char);
        procedure SwapBits(const Matrix : array of byte;
                           const Block  : array of char;
                           var BlockOut : array of char);
        procedure ShlKey(const KeyIn : array of char; const LSKey : array of byte;
                         const Count : byte; var KeyOut : array of char);
        procedure FuncDes(const SI : array of char; var RN : array of char);
      public
        procedure DES(const INP : array of char; const Key : array of char;
                      var   OUT : array of char);
      end;

  implementation

    uses
      JCString;

    procedure TDes.GetValues(const Index : byte; var NByte, Bit : byte);
      begin
        NByte:=0;
        case Index of
          01..08 : NByte:=0;      { 1 -   ᨢ }
          09..16 : NByte:=1;      { 2 -   ᨢ }
          17..24 : NByte:=2;      { 3 -   ᨢ }
          25..32 : NByte:=3;      { 4 -   ᨢ }
          33..40 : NByte:=4;      { 5 -   ᨢ }
          41..48 : NByte:=5;      { 6 -   ᨢ }
          49..56 : NByte:=6;      { 7 -   ᨢ }
          57..64 : NByte:=7;      { 8 -   ᨢ }
        end;
        Bit:=Index mod MaxInd;
        if Bit = 0 then Bit:=8;
      end;

    function TDes.ReadBit(const Block : array of char; const Index : byte) : byte;
      var
        NByte, Bit : byte;
      begin
        GetValues(Index, NByte, Bit);
        case Bit of
          8 : ReadBit:=byte(Block[NByte]) and Mask1;
          7 : ReadBit:=byte(Block[NByte]) and (Mask1 + 001) div (Mask1 + 001);
          6 : ReadBit:=byte(Block[NByte]) and (Mask1 + 003) div (Mask1 + 003);
          5 : ReadBit:=byte(Block[NByte]) and (Mask1 + 007) div (Mask1 + 007);
          4 : ReadBit:=byte(Block[NByte]) and (Mask1 + 015) div (Mask1 + 015);
          3 : ReadBit:=byte(Block[NByte]) and (Mask1 + 031) div (Mask1 + 031);
          2 : ReadBit:=byte(Block[NByte]) and (Mask1 + 063) div (Mask1 + 063);
          1 : ReadBit:=byte(Block[NByte]) and (Mask1 + 127) div (Mask1 + 127);
        end;
      end;

    procedure TDes.WriteBit(const Index, WrBit : byte; var Block : array of char);
      var
        NByte, Bit : byte;
      begin
        GetValues(Index, NByte, Bit);
        case Bit of
          8 : if WrBit = 1
                then Block[NByte]:=char(byte(Block[NByte]) or  Mask1)
                else Block[NByte]:=char(byte(Block[NByte]) and Mask2);
          7 : if WrBit = 1
                then Block[NByte]:=char(byte(Block[NByte]) or  (Mask1 + 001))
                else Block[NByte]:=char(byte(Block[NByte]) and (Mask2 - 001));
          6 : if WrBit = 1
                then Block[NByte]:=char(byte(Block[NByte]) or  (Mask1 + 003))
                else Block[NByte]:=char(byte(Block[NByte]) and (Mask2 - 003));
          5 : if WrBit = 1
                then Block[NByte]:=char(byte(Block[NByte]) or  (Mask1 + 007))
                else Block[NByte]:=char(byte(Block[NByte]) and (Mask2 - 007));
          4 : if WrBit = 1
                then Block[NByte]:=char(byte(Block[NByte]) or  (Mask1 + 015))
                else Block[NByte]:=char(byte(Block[NByte]) and (Mask2 - 015));
          3 : if WrBit = 1
                then Block[NByte]:=char(byte(Block[NByte]) or  (Mask1 + 031))
                else Block[NByte]:=char(byte(Block[NByte]) and (Mask2 - 031));
          2 : if WrBit = 1
                then Block[NByte]:=char(byte(Block[NByte]) or  (Mask1 + 063))
                else Block[NByte]:=char(byte(Block[NByte]) and (Mask2 - 063));
          1 : if WrBit = 1
                then Block[NByte]:=char(byte(Block[NByte]) or  (Mask1 + 127))
                else Block[NByte]:=char(byte(Block[NByte]) and (Mask2 - 127));
        end;
      end;

    procedure TDes.SwapBits(const Matrix : array of byte;
                            const Block  : array of char;
                            var BlockOut : array of char);
      var
        i : byte;
      begin
        for i:=Low(Matrix) + 1 to High(Matrix) + 1
          do WriteBit(i, ReadBit(Block, Matrix[i - 1]), BlockOut);
      end;

    procedure TDes.ShlKey(const KeyIn : array of char; const LSKey : array of byte;
                          const Count : byte; var KeyOut : array of char);
      var
        i, j, k  : byte;
        Bit, l   : byte;
        m        : byte;
      begin
        k:=0;
        for i:=Low(KeyIn) to High(KeyIn) do KeyOut[i]:=KeyIn[i];
        for i:=1 to LSKey[Count - 1] do
          begin
            Bit:=0;
            l:=0;
            for j:=High(KeyOut) downto Low(KeyOut) do   { Byte : 7 to 1   }
              begin
                m:=MaxInd * (MaxInd - (MaxInd - j)) + 1;{ Index bit stream}
                l:=ReadBit(KeyOut, m);
                if j = (High(KeyOut) div 2) then
                  begin
                    k:=MaxInd * (MaxInd - (j + 1));      { j = 3 !        }
                    WriteBit(56, ReadBit(KeyOut, k - 3), KeyOut);
                  end;
                KeyOut[j]:=char(byte(KeyOut[j]) shl 1);
                KeyOut[j]:=char(byte(KeyOut[j]) + Bit);
                Bit:=l;
                if j = Low(KeyOut) then WriteBit(k - 4, Bit, KeyOut);
              end;
          end;
      end;

    procedure TDes.FuncDes(const SI : array of char; var RN : array of char);
      var
        i, j, k : byte;
        Bit     : byte;
        Index   : byte;
        RF      : Array41;
      begin
        Bit:=1;
        j:=0;
        for i:=1 to MaxInd div 2 do RF[i]:=#0;
        for i:=Low(SI) to High(SI) do
          begin
            Index:=2 * MaxInd * ((ReadBit(SI, Bit) shl 1) +
                                  ReadBit(SI, Bit + 5)) +
                                ((ReadBit(SI, Bit + 1) shl 3) +
                                 (ReadBit(SI, Bit + 2) shl 2) +
                                 (ReadBit(SI, Bit + 3) shl 1) +
                                 (ReadBit(SI, Bit + 4))) + 1;
            case (i + 1) of
              1 : j:=S1[Index];
              2 : j:=S2[Index];
              3 : j:=S3[Index];
              4 : j:=S4[Index];
              5 : j:=S5[Index];
              6 : j:=S6[Index];
              7 : j:=S7[Index];
              8 : j:=S8[Index];
            end;
            if (i mod 2) = 0 then k:=0;
            k:=k shl 4 + j;
            if (i + 1) mod 2 = 0 then RF[(i + 1) div 2]:=char(k);
            Bit:=Bit + MaxInd;
          end;
        SwapBits(P, RF, RN);
      end;

    procedure TDes.DES(const INP : array of char; const Key : array of char;
                       var   OUT : array of char);
      var
        AI, SS       : DArray;
        Key_1, Key_2 : Array21;
        Key_3, RR    : Array31;
        L0, R0, RF   : Array41;
        i, j         : byte;
      begin
        { First swap bits in one 64 bits block                            }
        SwapBits(IP, INP, AI);{ First step : T0 = IP(T), T0 = AI, T = INP }
        { Delete control bits in Security Key                             }
        SwapBits(PC_1, Key, Key_1);  { 64 bits -------> 56 bits (Key_1)   }
        { Operations to convert 64 bits block to two 32 bits block        }
        for j:=MaxInd downto 1 do
          if j > (MaxInd div 2)
            then R0[j - 4]:=AI[j]         { Ri - second 4 Bytes, 32 bits  }
            else L0[j]:=AI[j];            { Li - first  4 Bytes, 32 bits  }
            
        { MAIN 16 times circle                                            }
        for i:=1 to MaxInd * 2 do
          begin
            { Operations under Security Key                               }
            ShlKey(Key_1, LS, i, Key_2);    { 56 bits shl ---> 56 bits    }
            SwapBits(PC_2, Key_2, Key_3);   { 56 bits -------> 48 bits    }
            { Operations under main 64 bits block                         }
            SwapBits(E, R0, RR);            { 32 bits -------> 48 bits    }
            for j:=1 to MaxInd - 2          { RR xor Key ----> RR         }
              do RR[j]:=char(byte(RR[j]) xor byte(Key_3[j]));
            { R0 ---> RR  (i - 1 step)  and  Key_3  (i step)              }
            SwapBits(StE, RR, SS);  { 48 bits -----------> 64 bits        }
            for j:=1 to MaxInd      { SS and 11111100 ---> SS             }
              do SS[j]:=char(byte(SS[j]) and (Mask2 - 2));
            FuncDes(SS, RF);
            for j:=1 to MaxInd div 2
              do L0[j]:=char(byte(L0[j]) xor byte(RF[j]));
            Key_1:=Key_2;
          end;   { End of MAIN 16 times circle                            }
          
        for j:=MaxInd downto 1 do
          if j > (MaxInd div 2)
            then AI[j]:=R0[j - 4]    { Ri - second 4 Bytes                }
            else AI[j]:=L0[j];       { Li - first  4 Bytes                }
        SwapBits(IP_1, AI, OUT);
      end;

  BEGIN
  END.
